
package Akk.Silly;

import java.applet.Applet;
import java.awt.*;
import java.awt.image.PixelGrabber;
import java.awt.image.ImageObserver;
//import NetUtils.Transparent;

public class RunAround extends Applet implements Runnable {
    Image img;
    int imgwidth;
    int x = 0;
    int dx = 5;
    int timeout = 200;
    Thread thread;
    Color backgroundColor;
    String imgname;

    public void init() {
	imgname = getParameter("img");

	String s = getParameter("freq");
	if (s != null)
	    timeout = 10000 / Integer.valueOf(s).intValue();

	s = getParameter("dx");
	if (s != null)
	    dx = Integer.valueOf(s).intValue();

	s = getParameter("background");
	if (s != null) {
	    // parse the string as an HTML-style color code, i.e. 0xRRGGBB
	    int red = Integer.parseInt(s.substring(0, 2), 16);
	    int green = Integer.parseInt(s.substring(2, 4), 16);
	    int blue = Integer.parseInt(s.substring(4), 16);
	    backgroundColor = new Color( red, green, blue );
	}

	img = getImage(getDocumentBase(), imgname);
	imgwidth = img.getWidth(this);
    }

    public void start() {
	if (thread == null) {
	    thread = new Thread(this);
	    thread.start();
	}
    }
    public void stop() {
	if (thread != null) {
	    thread.stop();
	    thread = null;
	}
    }

    public void run() {
	while (true) {
	    try {Thread.currentThread().sleep(timeout);}
	    catch (InterruptedException e){}
	    repaint();
	}
    }

    public void paint(Graphics g) {
	// Transparent class only works if BackgroundReady is set;
	if (backgroundColor == null) {
	    // Try to get the background color from the 1, 1 point
	    // of the image:
	    int[] pixels = new int[1];
	    PixelGrabber pg = new PixelGrabber(img, 2, img.getHeight(this)/3,
					       1, 1, pixels,
					       0, imgwidth);
	    try {
		pg.grabPixels();
		if ((pg.status() & ImageObserver.ABORT) != 0) {
		    System.err.println("image fetch aborted or errored");
		}
		backgroundColor = new Color(pixels[0]);
	    }
	    catch (InterruptedException e) {
		System.err.println("interrupted waiting for pixels");
	    }
	    if (backgroundColor == null)
		backgroundColor = new Color(0);
	}

	g.setColor(backgroundColor);
	g.fillRect(0, 0, size().width, size().height);

	x = x + dx;
	if (x + imgwidth > size().width-2)
		x = 0;
	g.drawImage(img, x, 1, this);

    }

}
